//-----------------------------------------------------------------------------
//----- DynLength.cpp : 
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "DynLength.h"

//----- CDynLength
STDMETHODIMP CDynLength::InterfaceSupportsErrorInfo(REFIID riid) {
	static const IID* arr [] = { &IID_IDynLength} ;

	for ( int i =0 ; i < sizeof (arr) / sizeof (arr [0]) ; i++ ) {
		if ( InlineIsEqualGUID (*arr [i], riid) )
			return (S_OK) ;
	}
	return (S_FALSE) ;
}

//----- IDynamicProperty
STDMETHODIMP CDynLength::GetGUID (GUID *pPropGUID) {
	if ( pPropGUID == NULL )
		return (E_POINTER) ;
	memcpy (pPropGUID, &CLSID_DynLength, sizeof(GUID)) ;
	return (S_OK) ;
}

STDMETHODIMP CDynLength::GetDisplayName (BSTR *pBstrName) {
	if ( pBstrName == NULL )
		return (E_POINTER) ;
	*pBstrName =::SysAllocString (L" CDynLength") ;

	return (S_OK) ;
}

STDMETHODIMP CDynLength::IsPropertyEnabled (IUnknown *pUnk, BOOL *pbEnabled) {
	if ( pUnk == NULL )
		return (E_INVALIDARG) ;
	if ( pbEnabled == NULL )
		return (E_POINTER) ;

	*pbEnabled = TRUE ;

	return (S_OK) ;
}

STDMETHODIMP CDynLength::IsPropertyReadOnly (BOOL *pbReadOnly) {
	if ( pbReadOnly == NULL )
		return (E_POINTER) ;

	*pbReadOnly = FALSE ;

	return (S_OK) ;
}

STDMETHODIMP CDynLength::GetDescription (BSTR *pBstrName) {
	if ( pBstrName == NULL )
		return (E_POINTER) ;

	*pBstrName =::SysAllocString (L"  CDynLength") ;

	return (S_OK) ;
}

STDMETHODIMP CDynLength::GetCurrentValueName (BSTR *pBstrName) {
	if ( pBstrName == NULL )
		return (E_POINTER) ;
  //////////////////////////////////////////////////////////////////////////
  //                 
  //////////////////////////////////////////////////////////////////////////
  *pBstrName =::SysAllocString (L"ACAD_NOUNITS") ;
	return (S_OK) ;
}

STDMETHODIMP CDynLength::GetCurrentValueType (VARTYPE *pVarType) {
	if ( pVarType == NULL )
		return (E_POINTER) ;
  //////////////////////////////////////////////////////////////////////////
  //                 
  //////////////////////////////////////////////////////////////////////////
	*pVarType = VT_USERDEFINED;

	return (S_OK) ;
}


STDMETHODIMP CDynLength::GetCurrentValueData (IUnknown *pUnk, VARIANT *pVarData) {
	if ( pUnk == NULL )
		return (E_INVALIDARG) ;
	if ( pVarData == NULL )
		return (E_POINTER) ;
	::VariantInit (pVarData) ;
  //////////////////////////////////////////////////////////////////////////
  //           
  //////////////////////////////////////////////////////////////////////////
  V_VT(pVarData) = VT_R8 ;
  _variant_t l_sel;
  if (SUCCEEDED(m_pNotify->GetCurrentSelectionSet(&l_sel))) {
    	V_R8(pVarData) = GetSelectedLength(&l_sel);
  } else {
    	V_R8(pVarData) = 0.0;
  }
	return (S_OK) ;
}

STDMETHODIMP CDynLength::SetCurrentValueData (IUnknown *pUnk, const VARIANT varData) {
	if ( pUnk == NULL )
		return (E_INVALIDARG) ;

	return (S_OK) ;
}

STDMETHODIMP CDynLength::Connect (IDynamicPropertyNotify2 *pSink) {
	if ( pSink == NULL )
		return (E_POINTER) ;
	m_pNotify =pSink ;
	m_pNotify->AddRef () ;
	return (S_OK) ;
}

STDMETHODIMP CDynLength::Disconnect () {
	if ( m_pNotify ) {
		m_pNotify->Release () ;
		m_pNotify= NULL ;
	}
	return (S_OK) ;
}


