// (C) Copyright 2002-2012 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

//-----------------------------------------------------------------------------
//----- acrxEntryPoint.cpp
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "resource.h"

//-----------------------------------------------------------------------------
#define szRDS _RXST("")

//-----------------------------------------------------------------------------
//----- ObjectARX EntryPoint
class CDynPropsApp : public AcRxArxApp {

public:
	CDynPropsApp () : AcRxArxApp () {}

	virtual AcRx::AppRetCode On_kInitAppMsg (void *pkt) {
		// TODO: Load dependencies here

		// You *must* call On_kInitAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kInitAppMsg (pkt) ;
		
		// TODO: Add your initialization code here

		return (retCode) ;
	}

	virtual AcRx::AppRetCode On_kUnloadAppMsg (void *pkt) {
		// TODO: Add your code here

		// You *must* call On_kUnloadAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kUnloadAppMsg (pkt) ;

		// TODO: Unload dependencies here

		return (retCode) ;
	}

	virtual void RegisterServerComponents () {
		//----- Self-register COM server upon loading.
		if ( FAILED(::DllRegisterServer ()) )
			acutPrintf (_RXST("Failed to register COM server.\n")) ;
	}
	
	// The ACED_ARXCOMMAND_ENTRY_AUTO macro can be applied to any static member 
	// function of the CDynPropsApp class.
	// The function should take no arguments and return nothing.
	//
	// NOTE: ACED_ARXCOMMAND_ENTRY_AUTO has overloads where you can provide resourceid and
	// have arguments to define context and command mechanism.
	
	// ACED_ARXCOMMAND_ENTRY_AUTO(classname, group, globCmd, locCmd, cmdFlags, UIContext)
	// ACED_ARXCOMMAND_ENTRYBYID_AUTO(classname, group, globCmd, locCmdId, cmdFlags, UIContext)
	// only differs that it creates a localized name using a string in the resource file
	//   locCmdId - resource ID for localized command

	// Modal Command with localized name
	// ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MyCommand, MyCommandLocal, ACRX_CMD_MODAL)
	static void MyGroupMyCommand () {
		// Put your command code here

	}

	// Modal Command with pickfirst selection
	// ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MyPickFirst, MyPickFirstLocal, ACRX_CMD_MODAL | ACRX_CMD_USEPICKSET)
	static void MyGroupMyPickFirst () {
		ads_name result ;
		int iRet =acedSSGet (ACRX_T("_I"), NULL, NULL, NULL, result) ;
		if ( iRet == RTNORM )
		{
			// There are selected entities
			// Put your command using pickfirst set code here
		}
		else
		{
			// There are no selected entities
			// Put your command code here
		}
	}

	// Application Session Command with localized name
	// ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MySessionCmd, MySessionCmdLocal, ACRX_CMD_MODAL | ACRX_CMD_SESSION)
	static void MyGroupMySessionCmd () {
		// Put your command code here
	}

	// The ACED_ADSFUNCTION_ENTRY_AUTO / ACED_ADSCOMMAND_ENTRY_AUTO macros can be applied to any static member 
	// function of the CDynPropsApp class.
	// The function may or may not take arguments and have to return RTNORM, RTERROR, RTCAN, RTFAIL, RTREJ to AutoCAD, but use
	// acedRetNil, acedRetT, acedRetVoid, acedRetInt, acedRetReal, acedRetStr, acedRetPoint, acedRetName, acedRetList, acedRetVal to return
	// a value to the Lisp interpreter.
	//
	// NOTE: ACED_ADSFUNCTION_ENTRY_AUTO / ACED_ADSCOMMAND_ENTRY_AUTO has overloads where you can provide resourceid.
	
	//- ACED_ADSFUNCTION_ENTRY_AUTO(classname, name, regFunc) - this example
	//- ACED_ADSSYMBOL_ENTRYBYID_AUTO(classname, name, nameId, regFunc) - only differs that it creates a localized name using a string in the resource file
	//- ACED_ADSCOMMAND_ENTRY_AUTO(classname, name, regFunc) - a Lisp command (prefix C:)
	//- ACED_ADSCOMMAND_ENTRYBYID_AUTO(classname, name, nameId, regFunc) - only differs that it creates a localized name using a string in the resource file

	// Lisp Function is similar to ARX Command but it creates a lisp 
	// callable function. Many return types are supported not just string
	// or integer.
	// ACED_ADSFUNCTION_ENTRY_AUTO(CDynPropsApp, MyLispFunction, false)
	static int ads_MyLispFunction () {
		//struct resbuf *args =acedGetArgs () ;
		
		// Put your command code here

		//acutRelRb (args) ;
		
		// Return a value to the AutoCAD Lisp Interpreter
		// acedRetNil, acedRetT, acedRetVoid, acedRetInt, acedRetReal, acedRetStr, acedRetPoint, acedRetName, acedRetList, acedRetVal

		return (RTNORM) ;
	}
	
} ;

//-----------------------------------------------------------------------------
IMPLEMENT_ARX_ENTRYPOINT(CDynPropsApp)

ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MyCommand, MyCommandLocal, ACRX_CMD_MODAL, NULL)
ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MyPickFirst, MyPickFirstLocal, ACRX_CMD_MODAL | ACRX_CMD_USEPICKSET, NULL)
ACED_ARXCOMMAND_ENTRY_AUTO(CDynPropsApp, MyGroup, MySessionCmd, MySessionCmdLocal, ACRX_CMD_MODAL | ACRX_CMD_SESSION, NULL)
ACED_ADSSYMBOL_ENTRY_AUTO(CDynPropsApp, MyLispFunction, false)

/// <summary>
///     
/// </summary>
/// <param name="l_selection"> </param>
/// <returns></returns>
double GetSelectedLength(VARIANT *l_selection)
{
  double len = 0.0;
  HRESULT l_hr;
  try {
    UINT l_dim = ::SafeArrayGetDim(V_ARRAY(l_selection));
    if (l_dim == 1)
    {
      LONG l_lbound = 0, l_ubound = 0;
      ::SafeArrayGetLBound(V_ARRAY(l_selection), 1, &l_lbound);  
      ::SafeArrayGetUBound(V_ARRAY(l_selection), 1, &l_ubound);
      IUnknown *l_unkn = 0;
      for (LONG l_idx = l_lbound; l_idx <= l_ubound; l_idx++)
      {
        l_hr = ::SafeArrayGetElement(V_ARRAY(l_selection), &l_idx, &l_unkn);

        if (SUCCEEDED(l_hr))
        {
          if (l_unkn != NULL) {
            IAcadObject *l_base = 0;
            if (!SUCCEEDED (l_unkn->QueryInterface(IID_IAcadObject,(void **)&l_base))) {
              continue;
            }
            AcDbObjectId  l_oid;
            LONG_PTR l_long = 0;
            if (SUCCEEDED(l_base->get_ObjectID(&l_long))) {
              l_oid.setFromOldId(l_long);
            }
            l_base->Release();
            if (l_oid.isValid()) {
              AcDbObjectPointer<AcDbCurve> pCurv(l_oid,AcDb::kForRead);
              if (pCurv.openStatus() == Acad::eOk) {
                double param = 0.0;  pCurv->getEndParam(param);
                double l = 0.0; pCurv->getDistAtParam(param,l);
                len += l;
              }
            }
          }
        }
      }
    }
  } catch(...) { }
  ::VariantClear(l_selection);
  return len;
}

/// <summary>
///        
/// </summary>
/// <param name="l_selection"> </param>
/// <returns></returns>
double GetSelectedAngle(VARIANT *l_selection)
{
  double ang = 0.0;
  HRESULT l_hr;
  AcGePlane plan(AcGePoint3d::kOrigin, AcGeVector3d::kZAxis);
  try {
    UINT l_dim = ::SafeArrayGetDim(V_ARRAY(l_selection));
    if (l_dim == 1)
    {
      LONG l_lbound = 0, l_ubound = 0;
      ::SafeArrayGetLBound(V_ARRAY(l_selection), 1, &l_lbound);  
      ::SafeArrayGetUBound(V_ARRAY(l_selection), 1, &l_ubound);
      IUnknown *l_unkn = 0;
      for (LONG l_idx = l_lbound; l_idx <= l_ubound; l_idx++)
      {
        l_hr = ::SafeArrayGetElement(V_ARRAY(l_selection), &l_idx, &l_unkn);

        if (SUCCEEDED(l_hr))
        {
          if (l_unkn != NULL) {
            IAcadObject *l_base = 0;
            if (!SUCCEEDED (l_unkn->QueryInterface(IID_IAcadObject,(void **)&l_base))) {
              continue;
            }
            AcDbObjectId  l_oid;
            LONG_PTR l_long = 0;
            if (SUCCEEDED(l_base->get_ObjectID(&l_long))) {
              l_oid.setFromOldId(l_long);
            }
            l_base->Release();
            if (l_oid.isValid()) {
              AcDbObjectPointer<AcDbCurve> pCurv(l_oid,AcDb::kForRead);
              if (pCurv.openStatus() == Acad::eOk) {
                double param = 0.0;  pCurv->getStartParam(param);
                AcGeVector3d v;    pCurv->getFirstDeriv(param,v);
                ang += v.angleOnPlane(plan);
              }
            }
          }
        }
      }
    }
  } catch(...) { }
  ::VariantClear(l_selection);
  return ang;
}
